#!/bin/sh

PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin"
export PATH

XDIALOG_HIGH_DIALOG_COMPAT=1
export XDIALOG_HIGH_DIALOG_COMPAT

# Get root
[ "`id -u`" != "0" ] && exec sudo "$0" "$@"

TMP="/tmp/gprsconnect$$"

bailout(){
rm -f "$TMP"
exit 0
}

DIALOG="dialog"
[ -n "$DISPLAY" ] && [ -x /usr/bin/Xdialog ] && DIALOG="Xdialog"
trap bailout 1 2 3 15

# LANGUAGE etc.
[ -f /etc/sysconfig/knoppix ] && . /etc/sysconfig/knoppix
[ -z "$LANG" ] && export LANG
[ -z "$LANGUAGE" ] && export LANGUAGE
[ -z "$CHARSET" ] && export CHARSET

# Language-dependent Messages
case "$LANGUAGE" in
de*|at*|ch*)
TITLE0="Keine Schnittstelle angegeben"
MESSAGE0="Sie haben die Schnittstelle noch nicht eingerichtet, ber die das Modem oder das Handy erreichbar ist. Mchten Sie dies jetzt nachholen?"
TITLE1="GPRS"
MESSAGE1="GPRS Internet-Zugang jetzt starten?"
TITLE_LOG="GPRS Einbuchung wurde initiiert, Strg-C zum Beenden."
MESSAGE_DISCONNECT="GPRS beendet."
;;
*)
TITLE0="No modem device selected"
MESSAGE0="You have not configured a device for modem / cellphone access yet. Would you like to do this now?"
TITLE1="GPRS"
MESSAGE1="Start GPRS Internet Access now?"
TITLE_LOG="GPRS dialup initiated, hit Ctrl-C to disconnect."
MESSAGE_DISCONNECT="GPRS disconnected."
;;
esac

disconnect(){
poff
$DIALOG --clear --title "$TITLE1" --msgbox "$MESSAGE_DISCONNECT" 8 35
exit 0
}

trap disconnect 1 2 3 15

# MAIN
if [ ! -e /dev/modem ]; then
$DIALOG --title "$TITLE0" --yesno "$MESSAGE0" 8 65 || bailout
/usr/sbin/modemlink
[ -e /dev/modem ] || bailout
fi
$DIALOG --title "$TITLE1" --yesno "$MESSAGE1" 8 65 || bailout
[ -x /etc/init.d/sysklogd ] && /etc/init.d/sysklogd start >/dev/null 2>&1
# echo "AT" >/dev/modem
sleep 1
pon gprs
if [ -n "$DISPLAY" ] && type xterm >/dev/null; then
xterm -T "$TITLE_LOG" -e bash -c 'tail -f /var/log/messages | egrep -e "(chat|ppp)"'
else
tail -f /var/log/messages | egrep -e "(chat|ppp)"
fi

disconnect
